Subject: bug#22727: Managing packages writes the user init file

From: Eli Zaretskii <[email-masked]>
Date: Fri, 19 Feb 2016 11:40:28 +0200

> Cc: [email-masked], [email-masked]
> From: Angelo Graziosi <[email-masked]>
> Date: Thu, 18 Feb 2016 23:04:09 +0100
> 
> > If we solve this part, i.e. avoid modifying .emacs until the user
> > actually selects some packages to install, would that address your
> > concerns that triggered this bug report?
> 
> No.
> 
> 1.
> 
> As I tried to explain, I haven't opened this report to see fixed an 
> issue for me. Please read: 
> http://lists.gnu.org/archive/html/emacs-devel/2016-02/msg00989.html

Thanks, I've read that thread before writing the above.

> On emacs-devel there is a discussion in which others think Emacs should 
> not change the init file when one manages Emacs packages.

I thought this bug report was supposed to be the place where the issue
is discussed.  It sounds strange to me to file a bug, and then discuss
it elsewhere.

> 2.
> 
> Since I discovered this behavior, each time I need to manege packages (I 
> have some packages installed from MELPA), I save my init file and 
> restore it after the managing. So I never used those additions and Emacs 
> seems to work the same.

If the stuff written by package.el is not needed, then it should not
write it, I agree.

> Indeed I don't understand why installing packages should change MY
> init file..

Presumably because Emacs needs to know what is installed the next time
you invoke package.el.

> 3.
> 
> Anyway, I am not an Emacs developer so it could be the case that for 
> some obscure (to me) reason, Emacs needs those additions/informations. 
> If this is true, why not use another packages configuration files? On 
> emacs-devel it seems that other users/developers would prefer that.. 
> Given the nature of the addictions,
> 
> (custom-set-variables
>   ;; custom-set-variables was added by Custom.
>   ;; If you edit it by hand, you could mess it up, so be careful.
>   ;; Your init file should contain only one such instance.
>   ;; If there is more than one, they won't work right.
>   '(package-selected-packages (quote (bla bla bla))))
> (custom-set-faces
>   ;; custom-set-faces was added by Custom.
>   ;; If you edit it by hand, you could mess it up, so be careful.
>   ;; Your init file should contain only one such instance.
>   ;; If there is more than one, they won't work right.
>   )
> 
> why not to use a separate file also for Options - Customize Emacs?

As mentioned elsewhere, you can customize the variable custom-file to
have that.